// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from automotive_navigation_msgs:msg/DesiredDestination.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__DESIRED_DESTINATION__FUNCTIONS_H_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__DESIRED_DESTINATION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "automotive_navigation_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "automotive_navigation_msgs/msg/detail/desired_destination__struct.h"

/// Initialize msg/DesiredDestination message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * automotive_navigation_msgs__msg__DesiredDestination
 * )) before or use
 * automotive_navigation_msgs__msg__DesiredDestination__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
bool
automotive_navigation_msgs__msg__DesiredDestination__init(automotive_navigation_msgs__msg__DesiredDestination * msg);

/// Finalize msg/DesiredDestination message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
void
automotive_navigation_msgs__msg__DesiredDestination__fini(automotive_navigation_msgs__msg__DesiredDestination * msg);

/// Create msg/DesiredDestination message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * automotive_navigation_msgs__msg__DesiredDestination__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
automotive_navigation_msgs__msg__DesiredDestination *
automotive_navigation_msgs__msg__DesiredDestination__create();

/// Destroy msg/DesiredDestination message.
/**
 * It calls
 * automotive_navigation_msgs__msg__DesiredDestination__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
void
automotive_navigation_msgs__msg__DesiredDestination__destroy(automotive_navigation_msgs__msg__DesiredDestination * msg);

/// Check for msg/DesiredDestination message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
bool
automotive_navigation_msgs__msg__DesiredDestination__are_equal(const automotive_navigation_msgs__msg__DesiredDestination * lhs, const automotive_navigation_msgs__msg__DesiredDestination * rhs);

/// Copy a msg/DesiredDestination message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
bool
automotive_navigation_msgs__msg__DesiredDestination__copy(
  const automotive_navigation_msgs__msg__DesiredDestination * input,
  automotive_navigation_msgs__msg__DesiredDestination * output);

/// Initialize array of msg/DesiredDestination messages.
/**
 * It allocates the memory for the number of elements and calls
 * automotive_navigation_msgs__msg__DesiredDestination__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
bool
automotive_navigation_msgs__msg__DesiredDestination__Sequence__init(automotive_navigation_msgs__msg__DesiredDestination__Sequence * array, size_t size);

/// Finalize array of msg/DesiredDestination messages.
/**
 * It calls
 * automotive_navigation_msgs__msg__DesiredDestination__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
void
automotive_navigation_msgs__msg__DesiredDestination__Sequence__fini(automotive_navigation_msgs__msg__DesiredDestination__Sequence * array);

/// Create array of msg/DesiredDestination messages.
/**
 * It allocates the memory for the array and calls
 * automotive_navigation_msgs__msg__DesiredDestination__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
automotive_navigation_msgs__msg__DesiredDestination__Sequence *
automotive_navigation_msgs__msg__DesiredDestination__Sequence__create(size_t size);

/// Destroy array of msg/DesiredDestination messages.
/**
 * It calls
 * automotive_navigation_msgs__msg__DesiredDestination__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
void
automotive_navigation_msgs__msg__DesiredDestination__Sequence__destroy(automotive_navigation_msgs__msg__DesiredDestination__Sequence * array);

/// Check for msg/DesiredDestination message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
bool
automotive_navigation_msgs__msg__DesiredDestination__Sequence__are_equal(const automotive_navigation_msgs__msg__DesiredDestination__Sequence * lhs, const automotive_navigation_msgs__msg__DesiredDestination__Sequence * rhs);

/// Copy an array of msg/DesiredDestination messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
bool
automotive_navigation_msgs__msg__DesiredDestination__Sequence__copy(
  const automotive_navigation_msgs__msg__DesiredDestination__Sequence * input,
  automotive_navigation_msgs__msg__DesiredDestination__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__DESIRED_DESTINATION__FUNCTIONS_H_
